/**
 * spreadingsheet - Tablecalc impl. 
 */

class CalcTable {

	constructor() {
		this.val = [0, 0];
		this.select = "*";
		this.swap = false;
	}

	//commutative? swap operands
	swapOp(i, j) {
		let a = i;
		let b = j;
		if (this.swap) {
			[a, b] = [b, a]
		}
		return [a, b];
	}

	//select operation
	mode() {
		let expr = 0;

		if (this.select === "*") {
			expr = `,${this.val[0] * this.val[1]}`;
		} else if (this.select === "-") {
			expr = `,${this.val[0] - this.val[1]}`;
		} else if (this.select === "/") {
			expr = `,${this.val[0] / this.val[1]}`;
		} else if (this.select === "%") {
			expr = `,${this.val[0] % this.val[1]}`;
		} else if (this.select === "+") {
			expr = `,${this.val[0] + this.val[1]}`;
		} else {
			expr = `,${2 * (this.val[0] + this.val[1])}`;
		}
		return expr;
	}

	//create operation matrix (m x n)
	calc() {		
		let res = "";

		//columns of the first row		
		for (let k = 0; k <= this.n; k++) {
			(k === 0) ? res = this.select : res += `,${k}`;
		}
		res += "\r\n";
		for (let i = 1; i <= this.m; i++) {
			//rows of the first column 
			res += i;
			for (let j = 1; j <= this.n; j++) {
				this.val = this.swapOp(i, j);
				res += this.mode();
			}
			if (i !== this.n) res += `\r\n`;
		}
		return res;
	}
}
